#pragma once

#include "AbstractCommand.h"
#include "TipControl.h"
#include "NPSingleton.h"
#include "NProtoTypeFactory.h"
#include "ScriptletAction.h"

namespace tipuio {

#define DECLARE_PROPERTY_TIPACTION(CREATOR) \
	static int sm_TipCommandID;	

#define REGISTER_TIPACTION_CREATOR(CREATORID, CREATOR) \
	int CREATOR::sm_TipCommandID = TipCommandFactory::get_instance()->RegisterProtoType(CREATORID, new CNDefaultCloneable< CREATOR >);


class NPCOMMONUI_API TipCommandFactory : public CNProtoTypeFactory
{
public:
	DECLARE_SINGLETON_CODE(TipCommandFactory);
	TipCommandFactory() {}
	virtual ~TipCommandFactory() {}

	AbstractCommand* CreateAction(LPCTSTR id);
	void DestroyAction(AbstractCommand* command);
};

class NPCOMMONUI_API TipCommand : public AbstractCommand
{
public:
	TipCommand(void);
	virtual ~TipCommand(void);

	//override
	BOOL Execute();
	BOOL ExecuteImpl();
	
	//operation
	void SetControl(AbstractControl* control) { m_Control = control; }
	AbstractControl* GetControl() { return m_Control; }
	AbstractView* GetView();
	AbstractModel* GetModel();

private:
	AbstractControl* m_Control;
};

template <class TBase>
class Action2CommandBridge : public IActionListener
{
public:
	Action2CommandBridge(void) {}
	virtual ~Action2CommandBridge(void) {}

	void OnActionPerformed(CComponent* pComponent)
	{
		TipCommand* command = dynamic_cast<TipCommand*>(TipCommandFactory::get_instance()->CreateAction(TBase::GetActionName()));
		if (command)
			command->Execute();
	}	
};

};